function Right(str, n){
    if (n <= 0)
       return "";
    else if (n >= str.length)
       return str;
    else {
       var iLen = str.length-1;
       return str.substring(iLen, iLen - n);
    }
}
function Left(str, n){
if (n <= 0)
   return "";
else if (n >= str.length)
    return str;
else
  return str.substring(0,n);
}
function CStr(x) {
 return x.toString();
}
function Int(x) {
 return Math.floor(x);
}
function HexToInt(x) { try { if (x==null) { return 0; }  x=x.trim(); if (x.length==0) { return 0; } if (x.indexOf("#")>-1) {    x=x.replaceAll("#","0x"); } else  if (x.indexOf("$")>-1) {    x=x.replaceAll("$","0x"); } else  if (x.indexOf("&H")>-1) {    x=x.replaceAll("&H","0x"); } else   if (x.indexOf("0x")==-1) {    x="0x"+x; }       return parseInt(x);  } catch {return 0;}}

function adjust(color, amount) {
	return '#' + color.replace(/^#/, '').replace(/../g, color => ('0' + Math.min(255, Math.max(0, parseInt(color, 16) + amount)).toString(16)).substr(-2));
}
function RGBToHex(rgb) {
	let sep = rgb.indexOf(",") > -1 ? "," : " ";
	rgb = rgb.substr(4).split(")")[0].split(sep);
	let r = (+rgb[0]).toString(16),
	g = (+rgb[1]).toString(16),
	b = (+rgb[2]).toString(16);
	if (r.length == 1)
		r = "0" + r;
	if (g.length == 1)
		g = "0" + g;
	if (b.length == 1)
		b = "0" + b;
	return "#" + r + g + b;
}


function Val(s) { 

  try { 
   if (s==null) return 0;
   if (typeof s == "number") return s;
   if (typeof s != "string") return 0;
   if (s.length==0) return 0;
   var test1=""; test1=s.trim(); 
   
   var i=test1.indexOf(''); if (i>-1) { test1 = test1.split(' ')[1];  }
   
 if ((test1.indexOf("#")>-1)||(test1.indexOf("$")>-1)||(test1.indexOf("0x")>-1)||(test1.indexOf("&H")>-1)) {	   return HexToInt(test1);	  } 
  else { 
  return parseFloat(test1); 
  }	   } 
 catch { return 0; } 
}

function Len(x) {
  return x.length;
}
function RGB(r, g, b) {
 var s="";
 s="#"+r.toString(16)+g.toString(16)+b.toString(16);
 return s;
}
function IntToHex(x,e) { try { if (x==null) { return "000000"; } if (e==null) { e=6; } var s=""; s=x.toString(16); var l=e-s.length; if (l>0) { for (var i=0; i<l;i++) {    s="0"+s;  } } return s; } catch { return "#000000"; } }
function ColorString(x) { return "#"+IntToHex(x,6); }
function GetRValue(x) {  return Val('#'+ColorString(x).substring(1,3)); }
function GetGValue(x) {  return Val('#'+ColorString(x).substring(3,5)); }
function GetBValue(x) {  return Val('#'+ColorString(x).substring(5,7)); }

function MaxColorLevel( s )  { 
 var x=Val(s);
 var r=GetRValue(x);var g=GetGValue(x);var b=GetBValue(x);
 if (g>r) { r=g;} if (b>r) { r=b;}
 return r;
}

function InStr(s, s1){
 if (s==undefined) {
  return 0;
} else
 {
 return  s.indexOf(s1)+1;
 }
}

function ValElse(s,n) {
if (s.length==0) {
 return n;
} else
{
  return parseFloat(s);
}
}
function slope(x1,y1,x2,y2) {
  var a;
  var dx;
    dx=(x1-x2);
    if (dx!=0) { 
     a=(y1-y2)/dx;
    } else
    {
     a=0;
    }
 return a;	
}

function intercept(x1,y1,x2,y2) {
    var b;
          var dx;
    dx=(x1-x2);
    if (dx!=0) { 
     b=(x1*y2-x2*y1)/dx;
    } else
    {
     b=0;
    }
 return b;	
}
function f1g(x1,y1,x2,y2,x) {
var a=slope(x1,y1,x2,y2);
var b=intercept(x1,y1,x2,y2);
return a*x+b;
}
    function SetWorkSpace(x1, y1, x2, y2) {
    	var ex1=p2x(x1);
    	var ey1=p2y(y1);
    	var ex2=p2x(x2);
    	var ey2=p2y(y2);
    	this.wx1=ex1;
    	this.wy1=ey1;
    	this.wx2=ex2;
    	this.wy2=ey2;
    }
function p2x(x) {
 if (this.Proportional) {
  this.PixelsPerUnitX=(this.wx2-this.wx1)/100;
  return this.wx1+Math.round((x*this.PixelsPerUnitX));
 } else
 {
  return x;
 }
		}

function p2y(y) {
  if (this.Proportional) {
        this.PixelsPerUnitY=(this.wy2-this.wy1)/100;
      return this.wy1+Math.round((y*this.PixelsPerUnitY));
  } else
  {
  return y;
  }
       
}
function x2p(x) {
  if (this.Proportional) {
       this.PixelsPerUnitX=this.Width/100;
        return x/this.PixelsPerUnitX;
  } else {
	return x;  
  }
}
function y2p(y) {
  if (this.Proportional) {
 this.PixelsPerUnitY=this.Height/100;
 return y/this.PixelsPerUnitY;
  } else {
   return y;
  }
}

function FillRect(x1,y1,x2,y2) {
 this.ctx.fillStyle=this.BrushColor;
 var dx=this.p2x(x2)-this.p2x(x1);
 var dy=this.p2y(y2)-this.p2y(y1);
 this.ctx.fillRect(this.p2x(x1),this.p2y(y1),dx,dy);
}

function GradFillRect(x1,y1,x2,y2) { 
 
 var dx=this.p2x(x2)-this.p2x(x1);
 var dy=this.p2y(y2)-this.p2y(y1);
 
 

 var grd = this.ctx.createLinearGradient(this.p2x(x1), this.p2x(y1), this.p2x(x2), this.p2x(y1));
 grd.addColorStop(0, this.BrushColor);
 grd.addColorStop(0.5, adjust(this.BrushColor,111));
 grd.addColorStop(1, this.BrushColor);

 this.ctx.fillStyle = grd;
 
 
 
 this.ctx.fillRect(this.p2x(x1),this.p2y(y1),dx,dy);

 

}


function MoveTo(x1,y1) {
 this.MTx=x1;
 this.MTy=y1;
}
function LineTo(x1,y1) {
 this.ctx.strokeStyle=this.PenColor;
 this.ctx.moveTo(this.p2x(this.MTx),this.p2y(this.MTy));
 this.ctx.lineTo(this.p2x(x1),this.p2y(y1));
 this.ctx.stroke();
 this.MTx=x1;
 this.MTy=y1;
}
function TextOut(x1,y1,s) {
 this.ctx.fillStyle=this.FontColor;
 var h1=Int(this.p2y(this.FontSize));
 this.FontHeight=this.FontSize;
 this.ctx.font=h1+"px "+this.FontName;
 var x=this.p2x(x1);
 var y=this.p2y(y1)+this.p2y(this.FontHeight);
 this.ctx.fillText(s,x,y);
}
function SetFontSizeByFontHeight(y) {
 this.FontHeight=y;
 this.FontSize=y;
}
function Rectangle(x1,y1,x2,y2) {
 this.ctx.fillStyle=this.BrushColor;
 this.ctx.strokeStyle=this.PenColor;
 var dx=this.p2x(x2)-this.p2x(x1);
 var dy=this.p2y(y2)-this.p2y(y1);
 if (!this.Transparent) {
       this.ctx.fillRect(this.p2x(x1),this.p2y(y1),dx,dy);
     }
 this.ctx.strokeRect(this.p2x(x1),this.p2y(y1),dx,dy);

}
function RectangleGrad(x1,y1,x2,y2, x,y,c1, c2,l1,e1) {
 Rectangle(x1,y1,x2,y2);
}
function AddColor(cor,r, g, b) {

		}
function TextHeight(texto) {
 return this.FontHeight;
}
function TextWidth(texto) {
 return x2p(this.ctx.measureText(texto).width);
}
		
function Draw3DBorder() {
}
function TLBAR (nomecanvas1) {
        this.nomecanvas1=nomecanvas1;
        this.SetWorkSpace=SetWorkSpace;
        this.p2x=p2x;
        this.p2y=p2y;
        this.x2p=x2p;
        this.y2p=y2p;
        this.FillRect=FillRect;
		this.GradFillRect=GradFillRect;
        this.MoveTo=MoveTo;
        this.LineTo=LineTo;
        this.TextOut=TextOut;
        this.SetFontSizeByFontHeight=SetFontSizeByFontHeight;
        this.Rectangle= Rectangle;
        this.RectangleGrad= RectangleGrad ;
        this.TextHeight= TextHeight ;
        this.TextWidth= TextWidth ;
        this.Draw3DBorder= Draw3DBorder ;
        this.drawbar=drawbar;
	this.wx1=0;
        this.wy1=0;
        this.wx2=640;
        this.wy2=480;
	this.Valor=""; 
	this.Executing=true;
	this.BitMap=false;
	this.BrushColor="#00EE00";
	this.PenColor="#0000EE";
	this.FontColor="#000000";
	this.FontSize=10;
	this.FontHeight=21;
	this.PenWidth=0;
	this.FontBold=false;
	this.Transparent=false;
	this.Proportional=true;
	this.FontName="Arial";
	this.PixelsPerUnitX=1;
	this.PixelsPerUnitY=1;	
	this.MTx;
	this.MTy;
	this.Width = 640;
	this.Height = 480;
        this.Executing = true;
        this.Bitmap = true;
        this.canvas = document.getElementById(this.nomecanvas1);
		this.canvasparallel = document.createElement("CANVAS");
		
		this.ctx = this.canvasparallel.getContext("2d");
        this.ctx1 = this.canvas.getContext("2d");
/////// Properties:
	this.TITULO="";
	this.MOSTRA_TITULO=1;
	this.MAXIMO=50;
	this.MINIMO=0;
	this.DIVISOES=10;
	this.TAMANHO_LETRA=5;
	this.COR_ESCALA="#000000";
	this.TITULO_FONTE="Arial";
	this.TITULO_TAMANHO=8;
	this.TITULO_COR="#000000";
	this.LIMITEINFERIOR=25;
	this.LIMITESUPERIOR=70;
	this.COR_DO_LIMITE="#00FFFF";

	this.COR_FORA_LIMITE="#FF0000";
	this.COR_DA_FRENTE="#FFFF00";
	this.COR_ABAIXO_LIMITE="#00FF00";

	this.COR_DO_FUNDO="#FFFFEE";
	this.COR_DO_FUNDO_ACIMA_LIMITE="#FFEEEE";
	this.COR_DO_FUNDO_BAIXO_LIMITE="#EEFFEE";
        this.HORIZONTAL=0;


	this.ESPESSURALIMITE=1;
	this.BORDA=1;
        this.metervert=metervert;


	
}

function drawbar() {

this.canvasparallel.width=this.canvas.width;
this.canvasparallel.height=this.canvas.height;

this.Width=this.canvas.width;
this.Height=this.canvas.height;
this.wx1=0;
this.wy1=0;
this.wx2=this.Width;
this.wy2=this.Height;

            this.BrushColor = this.COR_DO_FUNDO;
            this.FontColor = this.COR_DA_FRENTE;
            this.PenColor = this.COR_DA_FRENTE;
            this.FillRect (0,0,100,100);



/////// script:
	var s;
	Max = Val(this.MAXIMO) ; Min = Val(this.MINIMO);
	
	
	x = Val(this.Valor);
	borda1=this.BORDA;
	
	if (this.Executing) {
	 if ((this.Valor=="ERRO") || (Len(this.Valor)==0)) {
	
	  return;
	 }
	}
	
	this.Bitmap = true;
	
        li=this.LIMITEINFERIOR;
        ls=this.LIMITESUPERIOR;
		
        var c="#00EE00";	
        c = this.COR_DA_FRENTE;
	if (x<li) {
	 c = this.COR_ABAIXO_LIMITE;
	} else if (x>ls) {
	 c = this.COR_FORA_LIMITE;
	} else
        {
	 c = this.COR_DA_FRENTE;
	}

        var horiz=this.HORIZONTAL;

        var y2=100*(ls-Min)/(Max - Min);
    if (horiz==0) {
        y2=100-y2;
    }

        var y1=100*(li-Min)/(Max - Min);
    if (horiz==0) {
        y1=100-y1;
     }

        this.BrushColor = this.COR_DO_FUNDO_ACIMA_LIMITE;
        if (horiz==1) {
         this.GradFillRect (0,0,y2,100);
         } else{
         this.FillRect (0,0,100,y2);
                }

        this.BrushColor = this.COR_DO_FUNDO;
        if (horiz==1) {
        this.GradFillRect (y2,0,y1,100);
        } else
        {
        this.GradFillRect (0,y2,100,y1);
        }

        this.BrushColor = this.COR_DO_FUNDO_BAIXO_LIMITE;
        if (horiz==1) {
        this.GradFillRect (0,y1,100,100);
        } else
        {
        this.GradFillRect (y1,0,100,100);
        }

	y = 100 * (x - Min) / (Max - Min);
    if (horiz==0) {
	y = 100 - y                                  
    }
	px=this.PixelsPerUnitX; py=this.PixelsPerUnitY;
	margem = 50 / px;

        var dx=15;
        var dy=3;

        this.BrushColor = c;
        if (horiz==0) {
 	this.GradFillRect(dx,y,100-dx,100);
        } else
        {
 	 this.GradFillRect(0,dx,y,100-dx);
        }
	n=10;
	
	this.PenWidth=this.ESPESSURALIMITE;
	this.PenColor=this.COR_DO_LIMITE;

        if (horiz==0) {
        this.MoveTo(0,y); this.LineTo(dx,y);
        this.MoveTo(dx-5,y-dy); this.LineTo(dx,y);
        this.MoveTo(dx-5,y+dy); this.LineTo(dx,y);
         } else
         {
        this.MoveTo(y,0); this.LineTo(y,dx);
        this.MoveTo(y-dy,dx-5); this.LineTo(y,dx);
        this.MoveTo(y+dy,dx-5); this.LineTo(y,dx);
         }

	
        y=100*(li-Min)/(Max - Min);
    if (horiz==0) {
        y=100-y;
    }
        this.MoveTo(0,y); this.LineTo(100,y);
        y=100*(ls-Min)/(Max - Min);
      if (horiz==0) {
        y=100-y;
        }
        if (horiz==0) {
        this.MoveTo(0,y); this.LineTo(100,y);
        } else
         {
        this.MoveTo(y,0); this.LineTo(y,100);
         }
        this.PenWidth=0;
        this.Transparent=true;
        tamletra=this.TAMANHO_LETRA;
	this.PenColor=this.COR_ESCALA; this.FontColor=this.COR_ESCALA;
	this.FontName="Arial";
	this.Proportional=true;
	
        if (horiz==0) {	
  	this.metervert(7,0,60,100,this.DIVISOES+1,5,Min,Max,tamletra,0-7/px,1,1,15/px);
         }
	if (borda1==1) {
	 Draw3DBorder;
	}
	s=this.TITULO;
	if (this.MOSTRA_TITULO==1) {
	if (Len(s)!=0) {
	 this.FontName=this.TITULO_FONTE;
	 this.FontSize=this.TITULO_TAMANHO;
	 this.FontColor=this.TITULO_COR;
	 this.FontBold=true;
	 this.TextOut(1+5/this.PixelsPerUnitX,1+5/this.PixelsPerUnitY,s);
	 this.FontBold=false;
	}
	}
  
	return;
	
	}
	 function metervert(x1,y1,x2,y2,div1,div2,min1,max1,fsize,spx,dir,al,dx1) {
	  var s="";
          var min=min1;
          var max=max1;
          var auxmin=0;
///////          alert("Max: "+max);
	//  y1=y1+fsize/2; y2=y2-fsize/2;
	  if (dir==1) {
	   auxmin=min; 
           min=max;
           max=auxmin;
	  }
	  this.FontHeight = fsize;
          this.SetFontSizeByFontHeight(fsize);
	  a    = slope(1,y1, div1,y2 ); b    = intercept(1,y1 ,div1,y2 );
	  aval = slope(1,min,div1,max); bval = intercept(1,min,div1,max);

          var xxx=max*10/10;
////////          alert("Max: "+xxx);
          s=CStr(xxx);
////////          alert("Max: "+s);
          s="00000000";
	  fsize =this.TextWidth(s);
	  fsizemin=this.TextWidth(CStr(Int(min*10)/10));
////////          alert(1);
	  if (fsizemin>fsize) {
	   fsize=fsizemin;
	  }
////////          alert(2);
	//  largura = x2-x1-fsize*2;
	  largura=dx1;
////////          alert(3);
	  if (al==1) {
	   xleft = 3*fsize/2;
	   spx=0-spx;
	   x1=x2;  largura=0-largura;
	  } else {
	   spx=0;
	   xleft = 0;
	  }
////////          alert("div1 "+div1);
	  for (i=1;i<=div1;i++) {
	   y   = a    * i + b;
	   Num = aval * i + bval;
	   s = CStr(Int(Num*10)/10);
	   th = this.TextHeight(s) / 2;
	   this.Transparent=true;
////////           alert("i="+i);
	   if ((i>2) && (i<div1-1)) {
            this.FontName="Arial";
            this.TextOut(x1+spx,y-th,s);
	    this.MoveTo(x1,y); this.LineTo(x1+largura,y);
	    if (i<div1-2) {
	     yy1=y; yy2=(i+1)*a+b;
	     for (j=2;j<=div2;j++) {
	      yb=f1g(1,yy1,div2,yy2,j);
	      this.MoveTo(x1,yb);
	      if (j==Int((div2+1)/2)) {
	       this.LineTo(x1+3*largura/5,yb);
	      } else { 
	       this.LineTo(x1+2*largura/5,yb);
	      }

	     }
	    }
	   }
	  }


     this.ctx1.drawImage(this.canvasparallel, 0, 0);

	 }
	


function desenhabarra(id,valor,minimo,maximo,li,ls,cor,corfundo,corfora)
{
  var y = Math.floor(valor*1000)/1000;
  var barra1 = new TLBAR(id);
  barra1.MAXIMO = maximo;
  barra1.MINIMO = minimo;
  barra1.LIMITEINFERIOR = li;
  barra1.LIMITESUPERIOR = ls;
  barra1.COR_FORA_LIMITE=corfora;
  barra1.COR_DA_FRENTE=cor;
  barra1.COR_DO_FUNDO=corfundo;
  barra1.COR_ABAIXO_LIMITE=corfora;
  barra1.COR_DO_FUNDO_ACIMA_LIMITE=corfundo;
  barra1.COR_DO_FUNDO_BAIXO_LIMITE=corfundo;
  barra1.Valor = y;
  barra1.drawbar();
}
function desenhabarrahoriz(id,valor,minimo,maximo,li,ls,cor,corfundo,corfora,horiz)
{
  var y = Math.floor(valor*1000)/1000;
  var barra1 = new TLBAR(id);
  barra1.HORIZONTAL=horiz;
  barra1.MAXIMO = maximo;
  barra1.MINIMO = minimo;
  barra1.LIMITEINFERIOR = li;
  barra1.LIMITESUPERIOR = ls;
  barra1.COR_FORA_LIMITE=corfora;
  barra1.COR_DA_FRENTE=cor;
  
  var m=MaxColorLevel(corfundo);
  
  if (m<127) { barra1.COR_ESCALA='#FFFFFF'; } else {  barra1.COR_ESCALA='#333333'; }
  barra1.COR_DO_FUNDO=corfundo;
  barra1.COR_ABAIXO_LIMITE=corfora;
  barra1.COR_DO_FUNDO_ACIMA_LIMITE=corfundo;
  barra1.COR_DO_FUNDO_BAIXO_LIMITE=corfundo;
  barra1.Valor = y;
  barra1.drawbar();
}